workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == 'pipeline'
    - if: $CI_PIPELINE_SOURCE == 'web'

stages: 
  - configure

# Update GitOps Configuration
update-manifests:
  stage: configure
  image: 
    name: alpine/git:v2.32.0
    entrypoint: ["/bin/sh", "-c"]
  needs:
    - project: thaddeus.madison/the-application
      job: build-vars
      ref: master
      artifacts: true
  #to remove
  before_script:
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh && chmod 600 ~/.ssh
    - ssh-keyscan -H ${CI_SERVER_HOST} >> ~/.ssh/known_hosts
    - echo "${CONFIGURATION_SSH_PRIVATE_KEY}" |  tr -d ' ' | base64 -d | ssh-add -
    - git config --global user.email "git@gitlabrunner.com"
    - git config --global user.name "Gitlab Runner"
  script:
    - git clone "git@${CI_SERVER_HOST}:${CI_PROJECT_PATH}" "${IMAGE_TAG}"
    - cd ${IMAGE_TAG}
    - sed -i "s%^\(  repository:\).*$%\1 ${IMAGE_REPOSITORY}%g" chart/values-production.yaml
    - sed -i "s%^\(  tag:\).*$%\1 ${IMAGE_TAG}%g" chart/values-production.yaml
    - sed -i "s%^\(  envURL:\).*$%\1 ${GITLAB_ENVURL}%g" chart/values-production.yaml
    - sed -i "s%^\(  url:\).*$%\1 ${SERVICE_URL}%g" chart/values-production.yaml
    - sed -i "s%^\(  internalPort:\).*$%\1 ${SERVICE_PORT}%g" chart/values-production.yaml
    - git add .
    - |-
      if [ "$(git status --porcelain | wc -l)" -gt "0" ]; then
        git status
        git commit -m "Update the image with '${IMAGE_REPOSITORY}:${IMAGE_TAG}' (automated by GitLab CI)"
        git push origin "${CI_DEFAULT_BRANCH}" -o ci.skip
      fi
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
